<?php
//echo "php version: ".phpversion()."<br/><br/>";

interface ITemplate {
  public function getBlock($blockname, $content);
}

class userTemplate implements ITemplate {

	public $cacheFolder = "cache/";
	public $cacheTimeoutBlock = 5;

  public function getBlock($blockname, $content) {
		$filename = $this->getCacheFilename($blockname);
		if (file_exists($filename) and (time() - filemtime($filename) < $this->cacheTimeoutBlock)) {
			//  
			$content = "<font color='#CCBB00'><strong> </strong><br/>$filename<br /></font>".$this->getFilecontext($filename);
		} else {
			//  
			$this->setCache($blockname, $content);
			$content = "<font color='#CCBB00'><strong> </strong><br/>$content -&gt; $filename<br /></font>".$this->getFilecontext($content);
		}
		return $content;
	}
	
	private function getCacheFilename($blockname) {
		if (!file_exists($this->cacheFolder)) {
			mkdir($this->cacheFolder);
		}
		return $this->cacheFolder.$blockname.".cache";
	}
	
	private function getFilecontext($filename) {
		$result = "";
		if ((file_exists($filename)) and (is_readable($filename))) {
			$result = file_get_contents($filename, false); 
		}
		return $result;
	}

	private function setCache($blockname, $content) {
		ob_start();     
		echo $this->getFilecontext($content);
		$buffer = ob_get_contents(); 
		//ob_end_flush();
		ob_end_clean();
		$this->writeCache($blockname, $buffer);
	}
	
	private function writeCache( $blockname, $content) { 
		$filename = $this->getCacheFilename($blockname);
		if (!file_exists($filename) or is_writable($filename)) {
			$fp = fopen($filename, 'w'); 
			fwrite($fp, $content); 
			fclose($fp); 
		} else {
			echo "cache not write";
		}
	} 

}
?>